<?php
if (!defined('DC_RC_PATH')) { return; }

/* Add behavior callback, will be used for all types of posts (standard, page, galery item, ...) */
$core->addBehavior('coreMediaConstruct',array('dcImageMetaExtender','coreMediaConstruct'));

class dcImageMetaExtender {
	protected static $post_imgs = array();
	protected static $post_imgs_reg = '#(?:<img[^>]+src="(.+?)".*?>)#msu';
	
	protected static function photoMetaGeo($file, $meta)
	{
#myLog::log('file: '.$file);
		$exif = exif_read_data($file,'ANY_TAG');
#myLog::log('exif: '.print_r($exif, true));

		// Now parse latitude / longitude data
		$lon = self::getGps($exif['GPSLongitude'], $exif['GPSLongitudeRef']);
		$lat = self::getGps($exif['GPSLatitude'], $exif['GPSLatitudeRef']);
		$lonString = self::getGps($exif['GPSLongitude'], $exif['GPSLongitudeRef'], true);
		$latString = self::getGps($exif['GPSLatitude'], $exif['GPSLatitudeRef'], true);
#myLog::log('lat: '.$lat);
#myLog::log('lon: '.$lon);
		$meta->addChild('NumericLatitude', $lat);
		$meta->addChild('NumericLongitude', $lon);
		$meta->addChild('StringLatitude', $latString);
		$meta->addChild('StringLongitude', $lonString);
	}

	protected static function getGps($exifCoord, $hemi, $asString = false) {
		// Source: http://stackoverflow.com/questions/2526304/php-extract-gps-exif-data/2572991#2572991
#myLog::log('ExifCoord: '.print_r($exifCoord, true));
#myLog::log('Count: '.count($exifCoord));
		$degrees = count($exifCoord) > 0 ? self::gps2Num($exifCoord[0]) : 0;
		$minutes = count($exifCoord) > 1 ? self::gps2Num($exifCoord[1]) : 0;
		$seconds = count($exifCoord) > 2 ? self::gps2Num($exifCoord[2]) : 0;
#myLog::log("Deg: $degrees / Min: $minutes / Sec: $seconds");

		$flip = ($hemi == 'W' or $hemi == 'S') ? -1 : 1;

		if ($asString) {
			$seconds = round($seconds, 0);
			return $degrees . '°'. " $minutes' $seconds\" $hemi";
		} else {
			return $flip * ($degrees + $minutes / 60 + $seconds / 3600);
		}
	}

	protected static function gps2Num($coordPart) {
		$parts = explode('/', $coordPart);
		if (count($parts) <= 0)
			return 0;
		if (count($parts) == 1)
			return $parts[0];
		return floatval($parts[0]) / floatval($parts[1]);
	}

	# Behaviour
	public function coreMediaConstruct($media) {
		$media->addFileHandler('image/jpeg','create',array('dcImageMetaExtender','imageMetaExtend'));
	}

	public function imageMetaExtend($cur, $f, $id) {
		global $core;
		$file = $core->media->getPwd().'/'.$f;
#		myLog::log('file: '.$file);
		if (!file_exists($file)) {
			return false;
		}

#		myLog::log('cur: '.print_r($cur, true));
		$rs = $core->con->select(
			'SELECT media_id, media_path, media_title, '.
			'media_file, media_meta, media_dt, media_creadt, '.
			'media_upddt, media_private, user_id '.
			'FROM '.$core->prefix.'media '.
			"WHERE media_id = ".$cur->media_id." ");

		$c = $core->con->openCursor($core->prefix.'media');

		while ($rs->fetch()) {
			$meta = $rs->media_meta;
			$meta = @simplexml_load_string($rs->media_meta);
#			myLog::log('meta: '.print_r($meta, true));
			dcImageMetaExtender::photoMetaGeo($file, $meta);
#			myLog::log('meta: '.print_r($meta, true));
			$c->media_meta = $meta->asXML();
#			myLog::log('xml: '.$c->media_meta);
			$c->update('WHERE media_id = '.$cur->media_id);
		}

	}

}

?>
